#include<bits/stdc++.h>
using namespace std;
int main()
{
    int w,h,r,q,i,a,x,y,c,j;
    ios_base::sync_with_stdio(false);
    cout << fixed;
    cout << setprecision(10);
    cin >> w >> h >> r >> q;
    double b[w+1];
    for(i=0;i<=w;i++)
    {
        b[i]=h;
    }
    for(i=0;i<q;i++)
    {
        cin >> a;
        if(a==2)
        {
            cin >> x;
            cout << b[x]<< endl;
        }
        else
        {
            cin >> x >> y;
            c=x-r;
            for(j=c+1;j<c+2*r-1;j++)
            {
                b[j]=y-sqrt(r*r-(x-j)*(x-j));
            }
        }
    }
}